// MoneyMaker_031
// by aicccia @ www.forexfactory.com
// 2/20/2007
// frantacech touches added 2/2007

extern string Account_Settings = "---------- Account Settings";
extern bool   UseMoneyMgmt = true;  // if true, the lots size will increase based on account size 
extern double RiskPercent = 5.0;    // risk to calculate the lots size (only if mm is enabled)
extern double LotSize = 0.1;        // if mm off, order will be for this lot size
extern string General_Settings = "---------- General Settings";
extern int fastma=26;
extern int slowma=77;
extern int currency_momentum=48;
extern int trend_momentum=23;
extern int maxpipfromEMA=15;
extern int trending=3;
extern string Stop_Settings = "---------- Stop Settings";
extern bool use_stop=true;
extern double buy_maxhoursNeg=28;
extern double buy_maxpipsNeg=30;
extern double sell_maxhoursNeg=7;
extern double sell_maxpipsNeg=50;
extern string Spike_Settings = "---------- Spike Settings";
extern bool use_spike=true;
extern int SpikeHeight=56;
extern string EquitySave_Settings = "---------- Equity Save Settings";
extern bool use_EquitySave=false;
extern int startcountpips=71;
extern int startcounthours=12;
extern double MaxEquitytoLose=0.60;

string trend,buy,sell;
double  maxaveragepips;

double           MinLotSize=0;
double           MaxLotSize=0;
double           LotStep=0;
double           Decimals=0;
int              AcctLeverage=0;
int              CurrencyLotSize=0;
int              Spread;
string buy_comment = "MoneyMaker v31 - buy";
string sell_comment = "MoneyMaker v31 - sell";

int start()
  {
  double lot,fastt,sloww,currency_momentumA,currency_momentumB,currency_momentumC,currency_momentumD,trend_momentumFastA,
         trend_momentumFastB,trend_momentumFastC,trend_momentumFastD,average,width,averagepips,opentime,stopip,trend_momentumSlowA,
         trend_momentumSlowB,stopaverage,EquityPercent;
  int total,ticket,ope,i,cnt,open,block,big,can,spike,buyjump,selljump;
  
//*********************1-Hour definitions***********************************
  average=iMA(NULL,PERIOD_H1,3,0,MODE_EMA,PRICE_CLOSE,1);
  stopaverage=iMA(NULL,PERIOD_H1,3,0,MODE_EMA,PRICE_CLOSE,1);
  fastt=iMA(NULL,PERIOD_H1,fastma,0,MODE_EMA,PRICE_CLOSE,1);
  sloww=iMA(NULL,PERIOD_H1,slowma,0,MODE_EMA,PRICE_CLOSE,1);
  currency_momentumA=iCustom(NULL,PERIOD_H1,"OSMAMA",4,6,currency_momentum,1,currency_momentum,0,1);
  currency_momentumB=iCustom(NULL,PERIOD_H1,"OSMAMA",4,6,currency_momentum,1,currency_momentum,1,1);
  currency_momentumC=iCustom(NULL,PERIOD_H1,"OSMAMA",4,6,currency_momentum,1,currency_momentum,0,3);
  trend_momentumFastA=iCustom(NULL,PERIOD_H1,"OSMAMA",4,6,trend_momentum,1,trend_momentum,0,1);
  trend_momentumFastB=iCustom(NULL,PERIOD_H1,"OSMAMA",4,6,trend_momentum,1,trend_momentum,0,2);
  trend_momentumFastC=iCustom(NULL,PERIOD_H1,"OSMAMA",4,6,trend_momentum,1,trend_momentum,0,3);
  trend_momentumFastD=iCustom(NULL,PERIOD_H1,"OSMAMA",4,6,trend_momentum,1,trend_momentum,1,1);
  trend_momentumSlowA=iCustom(NULL,PERIOD_H1,"OSMAMA",6,8,slowma*3,currency_momentum*3,currency_momentum*3,0,1);
  trend_momentumSlowB=iCustom(NULL,PERIOD_H1,"OSMAMA",6,8,slowma*3,currency_momentum*3,currency_momentum*3,0,5);
 //**************************************************************************
  
//***********Misc. Definitions***************************************************
  total=OrdersTotal();
  width=MathAbs(fastt-sloww);
  EquityPercent=1-MaxEquitytoLose;
//*******************************************************************************

//************************Trade Size***********************************************
 
  // Global equity/risk based lot sizer

  AcctLeverage = AccountLeverage();
  MinLotSize = MarketInfo(Symbol(),MODE_MINLOT);
  //G_MaxLotSize = MarketInfo(Symbol(),MODE_MAXLOT);
  MaxLotSize = 50.0;
  LotStep = MarketInfo(Symbol(),MODE_LOTSTEP);
  CurrencyLotSize = MarketInfo(Symbol(),MODE_LOTSIZE);
  Spread = MarketInfo(Symbol(),MODE_SPREAD);

  if(LotStep == 0.01) {Decimals = 2;}
  if(LotStep == 0.1) {Decimals = 1;}

  if (UseMoneyMgmt)
  {
    lot = AccountEquity() * (RiskPercent * 0.01) / (CurrencyLotSize / AcctLeverage);
    lot = StrToDouble(DoubleToStr(lot,Decimals));
  }
  else
  {
    lot = LotSize;
  }

  if (lot < MinLotSize) {lot = MinLotSize;}
  if (lot > MaxLotSize) {lot = MaxLotSize;}

 //*****************************************************************************

//*************Checks for any Open Trades***********
  for(i=0;i<total;i++)
         {
         OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
            {
            if(OrderSymbol()==Symbol())
               {
              open++;
               }
            }
         }
 //************************************************
 
 //***********************Spike Detector**************************************
  if(use_spike==true)
     {
      if(MathAbs(Close[1]-Open[3])>SpikeHeight*Point) 
         {
          if(fastma>slowma)
               {
               if(trend_momentumFastB<0)
                  {
                  spike++;
                  } 
               }
           if(fastma<slowma)
               {
               if(trend_momentumFastB>0)
                  {
                  spike++;
                  } 
              }
          }
      }
//***************************************************************************
 //**************************Equity Save**************************************
if(use_EquitySave==true)
   { 
   for(i=0;i<total;i++)
      {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
          {
          if(OrderType()==OP_BUY)
            {
            opentime=(TimeCurrent()-OrderOpenTime())/3600.0;
            if((average>OrderOpenPrice()) && (MathAbs(average-OrderOpenPrice())>startcountpips*Point) && (opentime>startcounthours))
               {
               if(MathAbs(average-OrderOpenPrice())>maxaveragepips)
                 {
                 maxaveragepips=MathAbs(average-OrderOpenPrice());
                 }
               }
             }
          if(OrderType()==OP_SELL)
            {
            opentime=(TimeCurrent()-OrderOpenTime())/3600.0;
            if((average<OrderOpenPrice()) && (MathAbs(average-OrderOpenPrice())>startcountpips*Point) && (opentime>startcounthours))
               {
               if(MathAbs(average-OrderOpenPrice())>maxaveragepips)
                 {
                 maxaveragepips=MathAbs(average-OrderOpenPrice());
                 }
               }
             }
           }
         }
       }
 //************************************************************************     
 //*********************Jump Detector**************************************       
  if(((Open[2]<iMA(NULL,PERIOD_H1,fastma,0,MODE_EMA,PRICE_CLOSE,2)) &&
     (Close[1]>iMA(NULL,PERIOD_H1,slowma,0,MODE_EMA,PRICE_CLOSE,1))) ||
    ((Open[3]<iMA(NULL,PERIOD_H1,fastma,0,MODE_EMA,PRICE_CLOSE,3)) &&
     (Close[2]>iMA(NULL,PERIOD_H1,slowma,0,MODE_EMA,PRICE_CLOSE,2))) ||
    ((Open[4]<iMA(NULL,PERIOD_H1,fastma,0,MODE_EMA,PRICE_CLOSE,4)) &&
     (Close[3]>iMA(NULL,PERIOD_H1,slowma,0,MODE_EMA,PRICE_CLOSE,3))) ||
    ((Open[5]<iMA(NULL,PERIOD_H1,fastma,0,MODE_EMA,PRICE_CLOSE,5)) &&
     (Close[4]>iMA(NULL,PERIOD_H1,slowma,0,MODE_EMA,PRICE_CLOSE,4))))
     {
     buyjump++;
     }
 if(((Open[2]>iMA(NULL,PERIOD_H1,fastma,0,MODE_EMA,PRICE_CLOSE,2)) &&
     (Close[1]<iMA(NULL,PERIOD_H1,slowma,0,MODE_EMA,PRICE_CLOSE,1))) ||
    ((Open[3]>iMA(NULL,PERIOD_H1,fastma,0,MODE_EMA,PRICE_CLOSE,3)) &&
     (Close[2]<iMA(NULL,PERIOD_H1,slowma,0,MODE_EMA,PRICE_CLOSE,2))) ||
    ((Open[4]>iMA(NULL,PERIOD_H1,fastma,0,MODE_EMA,PRICE_CLOSE,4)) &&
     (Close[3]<iMA(NULL,PERIOD_H1,slowma,0,MODE_EMA,PRICE_CLOSE,3))) ||
    ((Open[5]>iMA(NULL,PERIOD_H1,fastma,0,MODE_EMA,PRICE_CLOSE,5)) &&
     (Close[4]<iMA(NULL,PERIOD_H1,slowma,0,MODE_EMA,PRICE_CLOSE,4))))
     {
     selljump++;
     }
//************************************************************************
//*********************To Open Trades**************************************
     
        
     if(open<1)
         {
        if((buyjump>0) && (spike<1) && (fastt<sloww) && (currency_momentumA>0) && ((currency_momentumC<0) || 
        (trend_momentumSlowA>trend_momentumSlowB)) && ((MathAbs(Ask-sloww)<width*2) || ((MathAbs(Ask-sloww))<maxpipfromEMA*Point)))
            {
            ticket=OrderSend(Symbol(),OP_BUY,lot,Ask,10,0,0,buy_comment,1,0,Blue);
            trend="buy";
            maxaveragepips=0;
            PlaySound("alert.wav");
            return(0);
            }
         if((trend=="buy") && (trend_momentumFastA>0) && (trend_momentumFastC<0) && (average>fastt) && (fastt>sloww)
            && ((MathAbs(Ask-fastt))<maxpipfromEMA*Point) && (trend_momentumSlowA>trend_momentumSlowB) && (fastt>sloww))
            {
            ticket=OrderSend(Symbol(),OP_BUY,lot,Ask,10,0,0,buy_comment,1,0,Blue);
            maxaveragepips=0;
            PlaySound("alert.wav");
            return(0);
            }
        if((selljump>0) && (fastt>sloww) && (spike<1) && (currency_momentumA<0) && ((currency_momentumC>0) ||
            (trend_momentumSlowA<trend_momentumSlowB)) && ((MathAbs(sloww-Bid)<width*2) || ((MathAbs(sloww-Bid))<maxpipfromEMA*Point))) 
            {
            ticket=OrderSend(Symbol(),OP_SELL,lot,Bid,10,0,0,sell_comment,1,0,Red);
            maxaveragepips=0;
            trend="sell";
            PlaySound("alert.wav");
            return(0);
            }
         if((trend=="sell") && (trend_momentumFastA<0) && (trend_momentumFastC>0) && (average<fastt) && (fastt<sloww)
            && ((MathAbs(fastt-Bid))<maxpipfromEMA*Point) && (trend_momentumSlowA<trend_momentumSlowB) && (fastt<sloww)) 
            {
            ticket=OrderSend(Symbol(),OP_SELL,lot,Bid,10,0,0,sell_comment,1,0,Red);
            maxaveragepips=0;
            PlaySound("alert.wav");
            return(0);
            }
         }
       
//***************************************************************************

//***********************Sets Stop, Protects from Loss***********************
if(use_stop==true)
      {
  for(i=0;i<total;i++)
      {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
          {
          if(OrderType()==OP_BUY && (stopaverage<OrderOpenPrice()))
                   {
                   averagepips=(MathAbs(OrderOpenPrice()-stopaverage))*10000.0;
                   opentime=(TimeCurrent()-OrderOpenTime())/3600.0;
                   stopip=(opentime/(buy_maxhoursNeg))*(opentime*(buy_maxpipsNeg/(buy_maxhoursNeg)))-buy_maxpipsNeg;
                   if(stopip<0)
                        {
                        if(MathAbs(averagepips/(stopip/opentime))>opentime)
                           {
                           can++;
                           }
                        }
                   if(stopip>0)
                        {
                        can++;
                        }
                     }
         if(OrderType()==OP_SELL && (stopaverage>OrderOpenPrice()))
                   {
                     averagepips=(MathAbs(stopaverage-OrderOpenPrice()))*10000.0;
                     opentime=(TimeCurrent()-OrderOpenTime())/3600.0;
                     stopip=((-opentime/(sell_maxhoursNeg))*(opentime*(sell_maxpipsNeg/(sell_maxhoursNeg)))+sell_maxpipsNeg);
                     if(stopip>0)
                           {
                           if((averagepips/(stopip/opentime))>opentime)
                              {
                              can++;
                              }
                           }
                     if(stopip<0)
                           {
                           can++;
                           }
                        }
                     } 
                  } 
               }
 //***************************************************************************     

//******************To Close Trades******************************************               
   for(cnt=0;cnt<total;cnt++)
         {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
            {
            if(OrderType()==OP_BUY) 
               {
                if((currency_momentumA<0) && (currency_momentumA<currency_momentumB) && (average<fastt) && 
                  (trend_momentumFastA<trend_momentumFastD) && (spike<1)) 
                     {
                     OrderClose(OrderTicket(),OrderLots(),Bid,10,Blue);
                     PlaySound("alert.wav");
                     return(0);
                     }
               if((can>0) && (spike<1)) 
                     {
                     OrderClose(OrderTicket(),OrderLots(),Bid,10,Blue);
                     PlaySound("alert.wav");
                     return(0);
                     }
               if((maxaveragepips>0) && ((maxaveragepips*EquityPercent)<(MathAbs(average-OrderOpenPrice()))))
                     {
                     OrderClose(OrderTicket(),OrderLots(),Bid,10,Blue);
                     PlaySound("alert.wav");
                     return(0);
                     }
               }
              if(OrderType()==OP_SELL) 
                 {
                 if((currency_momentumA>0) && (currency_momentumA>currency_momentumB) && (average>fastt) && 
                    (trend_momentumFastA>trend_momentumFastD) && (spike<1))
                     {
                     OrderClose(OrderTicket(),OrderLots(),Ask,10,Blue);
                     PlaySound("alert.wav");
                     return(0);
                     }
                 if((can>0) && (spike<1))
                     {
                     OrderClose(OrderTicket(),OrderLots(),Ask,10,Blue);
                     PlaySound("alert.wav");
                     return(0);
                     }
                 if((maxaveragepips>0) && ((maxaveragepips*EquityPercent)<(MathAbs(average-OrderOpenPrice()))))
                     {
                     OrderClose(OrderTicket(),OrderLots(),Bid,10,Blue);
                     PlaySound("alert.wav");
                     return(0);
                     }
                 
                  }
               }
            }
//*****************************************************************************
  Comment("Balance: ", AccountBalance(), ", Equity: ", AccountEquity(), ", Leverage: ", AcctLeverage, ", Spread: ", Spread, ", Lots: ",lot);

}
      